// CSGParams.h
// This file contains the definition of the CSGParams class.  This is an internal-only
// class for this application; it's purpose is to simplify the initialization and 
// handling of OLE CSG method parameters.

class CSGParamsClass
   {
   // Member variables
   public:
      LPDISPATCH ReplyDispatch;    // Dispatch pointer to our reply object; passed to CSG so it can reply
      BSTR AgeGen;                 // Age/Generation for SSG Share requests
      BSTR CacheIndex;             // Cache index for SSG requests
      BSTR CI;                     // Host CI (for SSG requests)
      BSTR ClientContext;          // Client context string
      BSTR ClientName;             // Name of our client application
      BSTR CSGName;                // CSG to which request will be sent
      BSTR Pathmon;                // Host Pathmon
      BSTR ReplayKey;              // Replay key for CSG 
      BSTR Message;                // Actual data
      BSTR Server;                 // Host server 
      BSTR Tag;                    // Tag for SSG requests  
      BSTR Term;                   // Term name for SSG requests
      short Status;                // Return status from waited call
      short SubStatus;             // Return substatus from waited call
      long Timeout;                // Timeout for waited calls
	  BSTR RequestID;              // RequestID returned by nowaited calls
      VARIANTARG VAgeGen;          // Variant version of AgeGen
      VARIANTARG VCacheIndex;      // Variant version of CacheIndex
      VARIANTARG VClientContext;   // Variant version of ClientContext
      VARIANTARG VCSGName;         // Variant version of CSGName
      VARIANTARG VPathmon;         // Variant version of Pathmon
      VARIANTARG VReplayKey;       // Variant version of ReplayKey 
      VARIANTARG VServer;          // Variant version of Server
      VARIANTARG VTag;             // Variant version of Tag
      VARIANTARG VTerm;            // Variant version of Term
      VARIANTARG VTimeout;         // Variant version of Timeout
      VARIANTARG VRequestID;       // Variant version of RequestID

   // Methods
   public:
      CSGParamsClass();                                                  // Standard constructor
      CSGParamsClass(const CSGParamsClass&);                             // Copy constructor
      ~CSGParamsClass();                                                 // Standard destructor
      CSGParamsClass& CSGParamsClass::operator=(const CSGParamsClass&);  // Assignment

   };  // class CSGParamsClass

// ***** End of file CSGParam.h

