// replycla.cpp : implementation file
// This file contains the reply class implementation.  It contains code for the various callback
// methods the CSG requires in order to send response data to the client application.  

#include "stdafx.h"
#include "CSGTestC.h"
#include "replycla.h"
#include "procs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern int ReplyReceived;

/////////////////////////////////////////////////////////////////////////////
// ReplyClass

IMPLEMENT_DYNCREATE(ReplyClass, CCmdTarget)

// Constructor
ReplyClass::ReplyClass()
   {
	EnableAutomation();                  // EnableAutomation enables OLE automation for this object
   }  // ReplyClass::ReplyClass


// Destructor
ReplyClass::~ReplyClass()
   {
   }  // ReplyClass::~ReplyClass


void ReplyClass::OnFinalRelease()
   {
	// When the last reference for an automation object is released
	//	OnFinalRelease is called.  This implementation deletes the 
	//	object.  
	delete this;
   }  // ReplyClass::OnFinalRelease


BEGIN_MESSAGE_MAP(ReplyClass, CCmdTarget)
	//{{AFX_MSG_MAP(ReplyClass)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Note that the parameter type for string parameters is BSTR (given by VTS_BSTR below) for
// purposes of the dispatch map, but that the reply routines themselves declare the parameters
// as LPCTSTR.  This is necessary to force MFC to convert between Unicode (16-bit character)
// strings and standard ANSI or MBCS character strings.  Declaring the formal params as
// BSTR (instead of LPCTSTR) will cause the actual unicode strings to be passed to the
// callback functions, which will lead to major problems with C string handling routines
// (due to embedded nulls in unicode strings).
BEGIN_DISPATCH_MAP(ReplyClass, CCmdTarget)
	//{{AFX_DISPATCH_MAP(ReplyClass)
	DISP_FUNCTION(ReplyClass, "CSGReply", CSGReply, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(ReplyClass, "SSGReply", SSGReply, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(ReplyClass, "SSGReplyPrivate", SSGReplyPrivate, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(ReplyClass, "SSGReplyShare", SSGReplyShare, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(ReplyClass, "SSGReplyStatus", SSGReplyStatus, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(ReplyClass, "SSGReplyListdev", SSGReplyListdev, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(ReplyClass, "SRVReply", SRVReply, VT_I2, VTS_PI2 VTS_PI2 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// ReplyClass message handlers

short ReplyClass::CSGReply(short *Status, short *SubStatus, LPCTSTR Reply, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optCSGSend);
   return 0;
   }  // ReplyClass::CSGReply


short ReplyClass::SSGReply(short *Status, short *SubStatus, LPCTSTR Reply, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optSSGSend);
   return 0;
   }  // ReplyClass::SSGReply


short ReplyClass::SSGReplyPrivate(short *Status, short *SubStatus, LPCTSTR CI, LPCTSTR Reply, LPCTSTR CacheIndex, LPCTSTR Tag, LPCTSTR Term, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optSSGSendPrivate);
   return 0;
   }  // ReplyClass::SSGReplyPrivate


short ReplyClass::SSGReplyShare(short *Status, short *SubStatus, LPCTSTR CI, LPCTSTR Reply, LPCTSTR AgeGen, LPCTSTR CacheIndex, LPCTSTR Tag, LPCTSTR Term, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optSSGSendShare);
   return 0;
   }  // ReplyClass::SSGReplyShare


short ReplyClass::SSGReplyStatus(short *Status, short *SubStatus, LPCTSTR Reply, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optSSGSendStatus);
   return 0;
   }  // ReplyClass::SSGReplyStatus


short ReplyClass::SSGReplyListdev(short *Status, short *SubStatus, LPCTSTR Reply, LPCTSTR CacheIndex, LPCTSTR Tag, LPCTSTR Term, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optSSGSendListdev);
   return 0;
   }  // ReplyClass::SSGReplyListdev


short ReplyClass::SRVReply(short *Status, short *SubStatus, LPCTSTR Reply, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID) 
   {
   ReplyReceived = TRUE;
   SetReplyMemberVars(*Status, *SubStatus, Reply, optSRVSend);
   return 0;
   }  // ReplyClass::SRVReply

// ***** End of file replycla.cpp *****


